## org.eclipse.uml2.codegen.ecore.genmodel.util
Class UML2GenModelUtil

    java.lang.Object
      org.eclipse.uml2.codegen.ecore.genmodel.util.UML2GenModelUtil

    public class UML2GenModelUtil

extends java.lang.Object

Constructor Summary
`protected` `UML2GenModelUtil()`

Method Summary
`static org.eclipse.emf.codegen.ecore.genmodel.GenAnnotation` `createGenAnnotation(org.eclipse.emf.codegen.ecore.genmodel.GenBase genBase, java.lang.String source)`
`static org.eclipse.emf.codegen.ecore.genmodel.GenFeature` `findGenFeature(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.ecore.EStructuralFeature ecoreFeature)`
`static org.eclipse.emf.codegen.ecore.genmodel.GenOperation` `findGenOperation(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.ecore.EOperation ecoreOperation)`
`static GenCacheAdapterScope` `getCacheAdapterScope(org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getDuplicateGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenOperation>` `getDuplicateGenOperations(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static java.lang.String` `getFormattedKeyFeatureName(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature, int index)`
`static java.lang.String` `getFormattedKeyFeatureNames(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static org.eclipse.emf.codegen.ecore.genmodel.GenAnnotation` `getGenAnnotation(org.eclipse.emf.codegen.ecore.genmodel.GenBase genBase, java.lang.String source, boolean createOnDemand)`
`static org.eclipse.emf.codegen.ecore.genmodel.GenOperation` `getImplementedCollidingGetGenOperation(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static org.eclipse.emf.codegen.ecore.genmodel.GenOperation` `getImplementedCollidingIsSetGenOperation(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static org.eclipse.emf.codegen.ecore.genmodel.GenOperation` `getImplementedCollidingSetGenOperation(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static org.eclipse.emf.codegen.ecore.genmodel.GenOperation` `getImplementedCollidingUnsetGenOperation(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getImplementedRedefinedGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenOperation>` `getImplementedRedefinedGenOperations(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getImplementedSubsetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getImplementedSubsetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, boolean listType)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getImplementedSupersetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getImplementedSupersetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, boolean listType)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getImplementedUnionGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static java.lang.String` `getImportedOperationsClassName(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static java.lang.String` `getImportedResourceBaseInterfaceName(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)`
`static java.lang.String` `getImportedResourceFactoryBaseInterfaceName(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)`
`static java.lang.String` `getImportedResourceFactoryInterfaceName(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)`
`static java.lang.String` `getImportedResourceInterfaceName(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)`
`static java.lang.String` `getInvariantPrefix(org.eclipse.emf.codegen.ecore.genmodel.GenModel genModel)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getIsSetSubsetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature unionGenFeature)`
`static java.lang.String` `getKeyFeatureParameter(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature, int index)`
`static java.lang.String` `getKeyFeatureParameter(org.eclipse.emf.codegen.ecore.genmodel.GenClass context, org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature, int index, boolean formal)`
`static java.lang.String` `getKeyFeatureParameter(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature, int index)` Deprecated.
`static java.lang.String` `getKeyFeatureParameter(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature, int index, boolean formal)` Deprecated.
`static java.lang.String` `getKeyFeatureParameters(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static java.lang.String` `getKeyFeatureParameters(org.eclipse.emf.codegen.ecore.genmodel.GenClass context, org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature, boolean formal)`
`static java.lang.String` `getKeyFeatureParameters(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)` Deprecated.
`static java.lang.String` `getKeyFeatureParameters(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature, boolean formal)` Deprecated.
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getKeyGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getKeyGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, boolean includeContains)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getKeyGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static java.lang.String` `getOCLBody(org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)`
`static java.lang.String` `getOperationsClassExtends(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static java.lang.String` `getOperationsClassName(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static java.lang.String` `getOperationsPackage(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)`
`static java.lang.String` `getOperationsPackageName(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)`
`static java.lang.String` `getQualifiedOperationsClassName(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static java.lang.String` `getQualifiedResourceInterfaceName(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getRedefinedGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getRedefinedGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenOperation>` `getRedefinedGenOperations(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenOperation>` `getRedefinedGenOperations(org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)`
`static java.lang.String` `getRedefinedListItemType(org.eclipse.emf.codegen.ecore.genmodel.GenClass context, org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static java.lang.String` `getRedefinedListItemType(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)` Deprecated.
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getRedefinitionGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenOperation>` `getRedefinitionGenOperations(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)`
`static java.lang.String` `getResourceInterfaceName(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)`
`static java.lang.String` `getSubsetFeatureAccessorArray(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature supersetGenFeature)`
`static java.lang.String` `getSubsetFeatureIDArray(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature supersetGenFeature)`
`static java.lang.String` `getSubsetFeatureIDArray(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature supersetGenFeature, boolean includeDerived)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getSubsetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getSubsetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature supersetGenFeature)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getSubsetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature supersetGenFeature, boolean includeDerived)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getSubsetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature supersetGenFeature, boolean includeDerived, boolean includeListType)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getSubsettedGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static java.lang.String` `getSupersetFeatureAccessorArray(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature subsetGenFeature)`
`static java.lang.String` `getSupersetFeatureIDArray(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature subsetGenFeature)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getSupersetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getSupersetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature subsetGenFeature)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getSupersetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature subsetGenFeature, boolean includeDerived)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getSupersetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature subsetGenFeature, boolean includeDerived, boolean includeListType)`
`static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature>` `getUnionGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static java.lang.String` `getUpperName(java.lang.String name)`
`static boolean` `hasOCLBody(org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)`
`static boolean` `hasOCLOperationBodies(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static boolean` `hasStringTypeKeyGenFeature(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static boolean` `isCacheAdapterSupport(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static boolean` `isCacheAdapterSupport(org.eclipse.emf.codegen.ecore.genmodel.GenModel genModel)`
`static boolean` `isCached(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static boolean` `isCached(org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)`
`static boolean` `isDerivedUnionListType(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static boolean` `isDuplicate(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static boolean` `isDuplicate(org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)`
`static boolean` `isEffectiveContainsSubset(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static boolean` `isFactoryMethods(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)`
`static boolean` `isFactoryMethods(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static boolean` `isFactoryMethods(org.eclipse.emf.codegen.ecore.genmodel.GenModel genModel)`
`static boolean` `isKey(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static boolean` `isOperationsClasses(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)`
`static boolean` `isPluralizedGetters(org.eclipse.emf.codegen.ecore.genmodel.GenModel genModel)`
`static boolean` `isRedefined(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static boolean` `isRedefined(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)`
`static boolean` `isRedefinition(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static boolean` `isRedefinition(org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)`
`static boolean` `isResourceCacheAdapterScope(org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)`
`static boolean` `isResourceInterfaces(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)`
`static boolean` `isSafeStrings(org.eclipse.emf.codegen.ecore.genmodel.GenModel genModel)`
`static boolean` `isSubset(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static boolean` `isSuperset(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass, org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static boolean` `isTest(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static boolean` `isUnion(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)`
`static boolean` `isXMLResource(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### UML2GenModelUtil

    protected UML2GenModelUtil()

Method Detail

### getUpperName

    public static java.lang.String getUpperName(java.lang.String name)

  Since:
    1.3

### createGenAnnotation

    public static org.eclipse.emf.codegen.ecore.genmodel.GenAnnotation createGenAnnotation(org.eclipse.emf.codegen.ecore.genmodel.GenBase genBase,
                                                                                           java.lang.String source)

### getGenAnnotation

    public static org.eclipse.emf.codegen.ecore.genmodel.GenAnnotation getGenAnnotation(org.eclipse.emf.codegen.ecore.genmodel.GenBase genBase,
                                                                                        java.lang.String source,
                                                                                        boolean createOnDemand)

### getInvariantPrefix

    public static java.lang.String getInvariantPrefix(org.eclipse.emf.codegen.ecore.genmodel.GenModel genModel)

### isCacheAdapterSupport

    public static boolean isCacheAdapterSupport(org.eclipse.emf.codegen.ecore.genmodel.GenModel genModel)

### isFactoryMethods

    public static boolean isFactoryMethods(org.eclipse.emf.codegen.ecore.genmodel.GenModel genModel)

### isPluralizedGetters

    public static boolean isPluralizedGetters(org.eclipse.emf.codegen.ecore.genmodel.GenModel genModel)

### isSafeStrings

    public static boolean isSafeStrings(org.eclipse.emf.codegen.ecore.genmodel.GenModel genModel)

### isResourceInterfaces

    public static boolean isResourceInterfaces(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)

### isOperationsClasses

    public static boolean isOperationsClasses(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)

### getOperationsPackage

    public static java.lang.String getOperationsPackage(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)

### getOperationsPackageName

    public static java.lang.String getOperationsPackageName(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)

### getResourceInterfaceName

    public static java.lang.String getResourceInterfaceName(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)

### getQualifiedResourceInterfaceName

    public static java.lang.String getQualifiedResourceInterfaceName(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)

### getImportedResourceInterfaceName

    public static java.lang.String getImportedResourceInterfaceName(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)

### getImportedResourceBaseInterfaceName

    public static java.lang.String getImportedResourceBaseInterfaceName(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)

### getImportedResourceFactoryInterfaceName

    public static java.lang.String getImportedResourceFactoryInterfaceName(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)

### getImportedResourceFactoryBaseInterfaceName

    public static java.lang.String getImportedResourceFactoryBaseInterfaceName(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)

### isXMLResource

    public static boolean isXMLResource(org.eclipse.emf.codegen.ecore.genmodel.GenPackage genPackage)

### getOperationsClassName

    public static java.lang.String getOperationsClassName(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### getQualifiedOperationsClassName

    public static java.lang.String getQualifiedOperationsClassName(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### getImportedOperationsClassName

    public static java.lang.String getImportedOperationsClassName(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### getOperationsClassExtends

    public static java.lang.String getOperationsClassExtends(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### getKeyGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getKeyGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### getKeyGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getKeyGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                                                      boolean includeContains)

### isFactoryMethods

    public static boolean isFactoryMethods(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                           org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### findGenFeature

    public static org.eclipse.emf.codegen.ecore.genmodel.GenFeature findGenFeature(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                                   org.eclipse.emf.ecore.EStructuralFeature ecoreFeature)

### findGenOperation

    public static org.eclipse.emf.codegen.ecore.genmodel.GenOperation findGenOperation(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                                       org.eclipse.emf.ecore.EOperation ecoreOperation)

### getDuplicateGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getDuplicateGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### getDuplicateGenOperations

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenOperation> getDuplicateGenOperations(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### isDerivedUnionListType

    public static boolean isDerivedUnionListType(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                 org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### getUnionGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getUnionGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### getImplementedUnionGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getImplementedUnionGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### getSubsetGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getSubsetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### getImplementedSubsetGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getImplementedSubsetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### getImplementedSubsetGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getImplementedSubsetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                                                                    boolean listType)

### getSupersetGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getSupersetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                                                           org.eclipse.emf.codegen.ecore.genmodel.GenFeature subsetGenFeature)

### getSupersetGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getSupersetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                                                           org.eclipse.emf.codegen.ecore.genmodel.GenFeature subsetGenFeature,
                                                                                                           boolean includeDerived,
                                                                                                           boolean includeListType)

### getSupersetGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getSupersetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                                                           org.eclipse.emf.codegen.ecore.genmodel.GenFeature subsetGenFeature,
                                                                                                           boolean includeDerived)

### getSupersetFeatureAccessorArray

    public static java.lang.String getSupersetFeatureAccessorArray(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                   org.eclipse.emf.codegen.ecore.genmodel.GenFeature subsetGenFeature)

### getSupersetFeatureIDArray

    public static java.lang.String getSupersetFeatureIDArray(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                             org.eclipse.emf.codegen.ecore.genmodel.GenFeature subsetGenFeature)

### isSuperset

    public static boolean isSuperset(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                     org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### getSupersetGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getSupersetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### getImplementedSupersetGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getImplementedSupersetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### getImplementedSupersetGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getImplementedSupersetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                                                                      boolean listType)

### getSubsetGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getSubsetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                                                         org.eclipse.emf.codegen.ecore.genmodel.GenFeature supersetGenFeature)

### getSubsetGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getSubsetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                                                         org.eclipse.emf.codegen.ecore.genmodel.GenFeature supersetGenFeature,
                                                                                                         boolean includeDerived)

### getSubsetGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getSubsetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                                                         org.eclipse.emf.codegen.ecore.genmodel.GenFeature supersetGenFeature,
                                                                                                         boolean includeDerived,
                                                                                                         boolean includeListType)

### getIsSetSubsetGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getIsSetSubsetGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                                                              org.eclipse.emf.codegen.ecore.genmodel.GenFeature unionGenFeature)

### getSubsetFeatureAccessorArray

    public static java.lang.String getSubsetFeatureAccessorArray(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                 org.eclipse.emf.codegen.ecore.genmodel.GenFeature supersetGenFeature)

### getSubsetFeatureIDArray

    public static java.lang.String getSubsetFeatureIDArray(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                           org.eclipse.emf.codegen.ecore.genmodel.GenFeature supersetGenFeature)

### getSubsetFeatureIDArray

    public static java.lang.String getSubsetFeatureIDArray(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                           org.eclipse.emf.codegen.ecore.genmodel.GenFeature supersetGenFeature,
                                                           boolean includeDerived)

### isRedefined

    public static boolean isRedefined(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                      org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### getRedefinedGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getRedefinedGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### getImplementedRedefinedGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getImplementedRedefinedGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### getRedefinitionGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getRedefinitionGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                                                               org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### isRedefined

    public static boolean isRedefined(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                      org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)

### getRedefinedGenOperations

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenOperation> getRedefinedGenOperations(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### getImplementedRedefinedGenOperations

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenOperation> getImplementedRedefinedGenOperations(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### getRedefinitionGenOperations

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenOperation> getRedefinitionGenOperations(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                                                                   org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)

### getImplementedCollidingGetGenOperation

    public static org.eclipse.emf.codegen.ecore.genmodel.GenOperation getImplementedCollidingGetGenOperation(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                                                             org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### getImplementedCollidingSetGenOperation

    public static org.eclipse.emf.codegen.ecore.genmodel.GenOperation getImplementedCollidingSetGenOperation(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                                                             org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### getImplementedCollidingIsSetGenOperation

    public static org.eclipse.emf.codegen.ecore.genmodel.GenOperation getImplementedCollidingIsSetGenOperation(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                                                               org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### getImplementedCollidingUnsetGenOperation

    public static org.eclipse.emf.codegen.ecore.genmodel.GenOperation getImplementedCollidingUnsetGenOperation(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                                                                               org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### isFactoryMethods

    public static boolean isFactoryMethods(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### isCacheAdapterSupport

    public static boolean isCacheAdapterSupport(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

### hasOCLOperationBodies

    public static boolean hasOCLOperationBodies(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass)

  Since:
    1.3

### isCached

    public static boolean isCached(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### isKey

    public static boolean isKey(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### isUnion

    public static boolean isUnion(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### isDuplicate

    public static boolean isDuplicate(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### isSubset

    public static boolean isSubset(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### isEffectiveContainsSubset

    public static boolean isEffectiveContainsSubset(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### getSubsettedGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getSubsettedGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### isRedefinition

    public static boolean isRedefinition(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### getRedefinedGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getRedefinedGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### getRedefinedListItemType

    @Deprecated
    public static java.lang.String getRedefinedListItemType(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

  Deprecated.

  Use `getRedefinedListItemType(GenClass, GenFeature)` with either `null` for erasing type parameter references or a `GenClass` context representing potential type substitutions for type parameter references. By default, this will just do `getRedefinedListItemType(genFeature.getGenClass(), genFeature)`.

  See Also:
    `getRedefinedListItemType(GenClass, GenFeature)`

### getRedefinedListItemType

    public static java.lang.String getRedefinedListItemType(org.eclipse.emf.codegen.ecore.genmodel.GenClass context,
                                                            org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

  Since:
    1.3

### getKeyGenFeatures

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenFeature> getKeyGenFeatures(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### hasStringTypeKeyGenFeature

    public static boolean hasStringTypeKeyGenFeature(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### getKeyFeatureParameter

    @Deprecated
    public static java.lang.String getKeyFeatureParameter(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature,
                                                                     int index)

  Deprecated.

  Use `getKeyFeatureParameter(GenClass, GenFeature, int)` with either `null` for erasing type parameter references or a `GenClass` context representing potential type substitutions for type parameter references. By default, this will just do `getKeyFeatureParameter(genFeature.getGenClass(), genFeature, index)`.

  See Also:
    `getKeyFeatureParameter(GenClass, GenFeature, int)`

### getKeyFeatureParameter

    public static java.lang.String getKeyFeatureParameter(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                          org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature,
                                                          int index)

  Since:
    1.3

### getKeyFeatureParameter

    @Deprecated
    public static java.lang.String getKeyFeatureParameter(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature,
                                                                     int index,
                                                                     boolean formal)

  Deprecated.

  Use `getKeyFeatureParameter(GenClass, GenFeature, int, boolean)` with either `null` for erasing type parameter references or a `GenClass` context representing potential type substitutions for type parameter references. By default, this will just do `getRedefinedListItemType(genFeature.getGenClass(), genFeature, index, formal)`.

  See Also:
    `getKeyFeatureParameter(GenClass, GenFeature, int, boolean)`

### getKeyFeatureParameter

    public static java.lang.String getKeyFeatureParameter(org.eclipse.emf.codegen.ecore.genmodel.GenClass context,
                                                          org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature,
                                                          int index,
                                                          boolean formal)

  Since:
    1.3

### getKeyFeatureParameters

    @Deprecated
    public static java.lang.String getKeyFeatureParameters(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

  Deprecated.

  Use `getKeyFeatureParameters(GenClass, GenFeature)` with either `null` for erasing type parameter references or a `GenClass` context representing potential type substitutions for type parameter references. By default, this will just do `getKeyFeatureParameters(genFeature.getGenClass(), genFeature)`.

  See Also:
    `getKeyFeatureParameters(GenClass, GenFeature)`

### getKeyFeatureParameters

    public static java.lang.String getKeyFeatureParameters(org.eclipse.emf.codegen.ecore.genmodel.GenClass genClass,
                                                           org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

  Since:
    1.3

### getKeyFeatureParameters

    @Deprecated
    public static java.lang.String getKeyFeatureParameters(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature,
                                                                      boolean formal)

  Deprecated.

  Use `getKeyFeatureParameters(GenClass, GenFeature, boolean)` with either `null` for erasing type parameter references or a `GenClass` context representing potential type substitutions for type parameter references. By default, this will just do `getKeyFeatureParameters(genFeature.getGenClass(), genFeature, formal)`.

  See Also:
    `getKeyFeatureParameters(GenClass, GenFeature)`

### getKeyFeatureParameters

    public static java.lang.String getKeyFeatureParameters(org.eclipse.emf.codegen.ecore.genmodel.GenClass context,
                                                           org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature,
                                                           boolean formal)

  Since:
    1.3

### getFormattedKeyFeatureName

    public static java.lang.String getFormattedKeyFeatureName(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature,
                                                              int index)

### getFormattedKeyFeatureNames

    public static java.lang.String getFormattedKeyFeatureNames(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### isTest

    public static boolean isTest(org.eclipse.emf.codegen.ecore.genmodel.GenFeature genFeature)

### isCached

    public static boolean isCached(org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)

### isResourceCacheAdapterScope

    public static boolean isResourceCacheAdapterScope(org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)

### getCacheAdapterScope

    public static GenCacheAdapterScope getCacheAdapterScope(org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)

### isDuplicate

    public static boolean isDuplicate(org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)

### isRedefinition

    public static boolean isRedefinition(org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)

### getRedefinedGenOperations

    public static java.util.List<org.eclipse.emf.codegen.ecore.genmodel.GenOperation> getRedefinedGenOperations(org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)

### getOCLBody

    public static java.lang.String getOCLBody(org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)

  Since:
    1.3

### hasOCLBody

    public static boolean hasOCLBody(org.eclipse.emf.codegen.ecore.genmodel.GenOperation genOperation)

  Since:
    1.3

Copyright 2003, 2007 IBM Corporation and others. All Rights Reserved.